@echo off
@setlocal enableextensions enabledelayedexpansion

set curdir=%~dp0
set curdir=%curdir:~0,-1%

cd /d "%curdir%"

for %%a in (firmware\*.nca) do (
	set nca=%%a
    set ncadirname=%%~na
    set ncaname=!ncadirname!.nca
    set /a ncasize=%%~za

    if !ncasize! GEQ 3145728 (
        if !ncasize! LEQ 3550000 (
            call :process
        )
    )
)

rmdir /s /q files > nul 2>&1

if exist *.ips (
    md fusee\atmosphere\kip_patches\fs_patches > nul 2>&1
    move /Y *.ips fusee\atmosphere\kip_patches\fs_patches\ > nul 2>&1
)

if exist *.txt (
    md hekate\bootloader > nul 2>&1
    type *.txt > hekate\bootloader\patches.ini 2>nul
    del *.txt
)

pause

goto :eof

:process
    hactool -t nca -k keys.dat --disablekeywarns --romfsdir="%ncadirname%" "%nca%" > nul 2>&1
    if not exist "%ncadirname%\nx\package2" (
        rmdir /s /q "%ncadirname%" > nul 2>&1
        exit /b
    )

    echo Found package2 in NCA %ncaname% with size %ncasize%

    hactool -t pk21 -k keys.dat --disablekeywarns --outdir="%ncadirname%\package2_ext" "%ncadirname%\nx\package2" > nul 2>&1
    hactool -t ini1 -k keys.dat --disablekeywarns --outdir="%ncadirname%\INI1_ext" "%ncadirname%\package2_ext\INI1.bin" > nul 2>&1

    rmdir /s /q files > nul 2>&1
    md files > nul 2>&1

    move /Y "%ncadirname%\INI1_ext\FS.kip1" files\FS.kip1 > nul 2>&1

    hactool -t kip1 -k keys.dat --disablekeywarns --uncompressed=files\FS-dec.kip1 files\FS.kip1 > nul 2>&1

    MakeIPS.exe

    rmdir /s /q "%ncadirname%" > nul 2>&1
